package betir;

/**
*   This class creates the attacker player class.  Attackers just go after the ball and
* 	have no zone behavior.  It adds five behaviors: StartBehavior, KiddySoccerBehavior
*	PassBehavior, CornerKickBehavior, and ShootGoalBehavior.
*/
public class Attacker extends Player
{
	Attacker(RobocupEnvironment theEnv, DatagramWrapper dg, int nPlayerNum, int nZone)
	{
		super(theEnv, dg, nPlayerNum, nZone);

		StartBehavior start = new StartBehavior(theEnv, dg);
		addBehavior(start);

		KiddySoccerBehavior dtb = new KiddySoccerBehavior(theEnv, dg);
		addBehavior(dtb);

		PassBehavior pb = new PassBehavior(theEnv, dg);
		addBehavior(pb);

		CornerKickBehavior ckb = new CornerKickBehavior(theEnv, dg);
		addBehavior(ckb);

		//TauntBehavior tb = new TauntBehavior(theEnv, dg);
		//addBehavior(tb);

		ShootGoalBehavior sgb = new ShootGoalBehavior(theEnv, dg);
		addBehavior(sgb);
	}
}
