package betir;


/**
*	This class is used by the goalie to catch the ball when it comes within range.
*	It simply checks the distance to the ball and if it is close enough it sends a
*	catch message to the soccer server.
*/
class CatchTheBall extends RobocupBehavior
{
	public CatchTheBall(RobocupEnvironment env, DatagramWrapper dg)
	{
		super(env, dg);
	}

	public boolean canFire()
	{
		return ((m_Env.m_objBall != null && m_Env.m_objBall.getDistance() < m_Env.m_cfgData.catchable_area_l && Math.abs(m_Env.m_objBall.getAngleChng()) < 10)
			|| (m_Env.m_strPlayMode.length() > 5 && m_Env.m_strPlayMode.charAt(0) == 'f' && m_Env.m_strPlayMode.charAt(5) == 'k' && m_Env.m_strPlayMode.charAt(10) == m_Env.m_objSelf.getSide()));
	}

	public boolean inhibits(RobocupBehavior rb)
	{
		return !(rb instanceof PassBehavior);
	}

	public boolean fire()
	{
		if(Math.abs(m_Env.m_vecPosition.getX()) < 45)
		{
			if(m_Env.m_objSelf.getSide() == 'r')
				turn(angleToAngle(165));
			else
				turn(angleToAngle(-15));
			m_dgWrapper.send("(change_view normal high)");
			turnHead(-m_Env.m_objSelf.getHeadAngle());
		}
		else if(m_Env.m_strPlayMode.length() > 5 && m_Env.m_strPlayMode.charAt(0) == 'f' && m_Env.m_strPlayMode.charAt(5) == 'k')
		{
			turnHead(-m_Env.m_objSelf.getHeadAngle());
			move(-37, 19);
		}
		else
			catchBall(m_Env.m_objBall.getAngle() + m_Env.m_objSelf.getHeadAngle());

		return false;
    }
}