package betir;

/**
*	This class is used by all players to kick the ball towards the middle
*	of the field when the player is in one of the corners, and can not
*	get a good shot at the goal.
*/
public class CornerKickBehavior extends RobocupBehavior
{
	public CornerKickBehavior(RobocupEnvironment env, DatagramWrapper dg)
	{
		super(env, dg);
	}

	public boolean canFire()
	{
		return (m_Env.m_bHasBall && Math.abs(m_Env.m_vecPosition.getX()) > 47 && Math.abs(m_Env.m_vecPosition.getY()) > 12);
	}

	public boolean inhibits(RobocupBehavior rb)
	{
		return (rb instanceof KiddySoccerBehavior || rb instanceof PassBehavior || rb instanceof ShootGoalBehavior);
	}

	public boolean fire()
	{
		if(withinRange(angleToPoint(0, 0), 0, 10))
		{
			kick(m_Env.m_cfgData.maxpower, angleToPoint(0, 0));
		}
		else
			turn(angleToPoint(0, 0));
		return false;
	}
}