package betir;

/**
*	This class creates the goalie.  It loads up five behaviors:
*	StartBehavior, GoalieUpDownBehavior, CatchTheBall, GoalieReturnToZoneBehavior,
*	and PassBehavior.
*/
public class Goalie extends Player
{
	Goalie(RobocupEnvironment theEnv, DatagramWrapper dg, int nPlayerNum, int nZone)
	{
		super(theEnv, dg, nPlayerNum, nZone);

		StartBehavior start = new StartBehavior(theEnv, dg);
		addBehavior(start);

		GoalieUpDownBehavior gudb = new GoalieUpDownBehavior(theEnv, dg);
		addBehavior(gudb);

		CatchTheBall cb = new CatchTheBall(theEnv, dg);
		addBehavior(cb);

		GoalieReturnToZoneBehavior grtzb = new GoalieReturnToZoneBehavior(theEnv, dg);
		addBehavior(grtzb);

		PassBehavior pb = new PassBehavior(theEnv, dg);
		addBehavior(pb);

		//TauntBehavior tb = new TauntBehavior(theEnv, dg);
		//addBehavior(tb);
	}
}
