package betir;

/**
*	This behavior brings the goalie back to the goal when he wanders too far away.
*/
public class GoalieReturnToZoneBehavior extends RobocupBehavior
{
	public GoalieReturnToZoneBehavior(RobocupEnvironment env, DatagramWrapper dg)
	{
		super(env, dg);
	}

	private boolean m_bIsFiring = false;
	public boolean canFire()
	{
		if(m_bIsFiring)
			return true;

		int nX = (m_Env.m_objSelf.getSide() == 'r') ? -(m_Env.m_Player.m_vecZone.getX()+1) : m_Env.m_Player.m_vecZone.getX()+1;
		if(m_Env.m_bAbsAngle && !withinRange(m_Env.m_vecPosition.getX(), nX, 2) && (m_Env.m_objBall == null ||
				(m_Env.m_objBall != null && m_Env.m_objBall.getDistance() > 5)))
		{
			m_bIsFiring = true;
			return true;
		}
		return false;
	}


	public boolean inhibits(RobocupBehavior rb)
	{
		if(rb instanceof CatchTheBall)
			return false;
		return (rb instanceof GoalieUpDownBehavior);
	}

	public boolean fire()
	{
		if(m_Env.m_aobjFlags.size() < 2)
		{
			turn(120);
			return false;
		}

		int nX = (m_Env.m_objSelf.getSide() == 'r') ? -m_Env.m_Player.m_vecZone.getX() : m_Env.m_Player.m_vecZone.getX();
		if(withinRange(m_Env.m_vecPosition.getX(), nX, 2))
		{
			m_bIsFiring = false;
			turn(angleToAngle(90));
			return false;
		}

		if(!withinRange(angleToPoint(m_Env.m_Player.m_vecZone.getX(), m_Env.m_Player.m_vecZone.getY()), 0, 3))
			turn(angleToPoint(m_Env.m_Player.m_vecZone.getX(), m_Env.m_Player.m_vecZone.getY()));
		else
		{
			m_bLastWasTurn = true;
			dashToPoint(m_Env.m_Player.m_vecZone.getX(), m_Env.m_Player.m_vecZone.getY());
		}
		return false;
	}
}