package betir;

/**
*	This is the most basic behavior that simply finds and runs towards the ball,
*	and then kicks it to the goal.
*/
public class KiddySoccerBehavior extends RobocupBehavior
{
	public KiddySoccerBehavior(RobocupEnvironment env, DatagramWrapper dg)
	{
		super(env, dg);
	}

	public boolean canFire()
	{
		return true;
	}

	public boolean inhibits(RobocupBehavior rb)
	{
		return false;
	}

	public boolean fire()
	{
		if(m_Env.m_bHasBall)
		{
			if(m_Env.m_objGoal != null && withinRange(m_Env.m_objGoal.getAngle(), 0, 10))
				kick(m_Env.m_cfgData.maxpower, m_Env.m_objGoal.getAngle());
			else if(m_Env.m_objGoal != null)
				turn(m_Env.m_objGoal.getAngle());
			else
				turn(angleToPoint(52, 0));
			changeView("normal", "high");
		}
		else if(m_Env.m_objBall != null)
		{
			dashToBall();
			changeView("normal", "high");
		}
		else
		{
			if(m_Env.m_bAbsAngle)
			{
				turn(100);
			}
			changeView("wide", "high");
		}
		return false;
	}
}