package betir;

/**
*	This is a container class for objects that robocup sees.
*/
public class ObjectInfo
{
	/** The distance from our player to the object*/
    protected float 	m_fDistance;
    /** The angle from our player to the object*/
    protected int 		m_nAngle;
    /** The time the object was seen*/
	protected int 		m_nTimeStamp;
	/** The name of the object*/
	private String 		m_strName;
    /** The distance that has changed since the last time step*/
    private float 		m_fDistChng;
    /** The Angle that has changed since the last time step*/
    private int 		m_nAngleChng;
	private boolean		m_bIsValid;
    private boolean 	m_bGotChanges;

//****************************************************************************************************************** constructors
    public ObjectInfo()
    {
		m_strName 		= "object";
		m_nTimeStamp 	= 0;
		m_fDistance	 	= 0;
		m_nAngle 		= 0;
		m_fDistChng 	= 0;
		m_nAngleChng 	= 0;
		m_bGotChanges 	= false;
		m_bIsValid 		= false;
	}
    public ObjectInfo(String strName, int nTimeStamp)
    {
		m_strName 		= strName;
		m_nTimeStamp 	= nTimeStamp;
        m_bGotChanges 	= false;
		m_bIsValid 		= false;
    }

    public ObjectInfo(String strName, int nTimeStamp, float fDistance, int nAngle, float fDistChng, int nAngleChng)
    {
        m_strName 		= strName;
		m_nTimeStamp 	= nTimeStamp;
        m_fDistance	 	= fDistance;
        m_nAngle 		= nAngle;
        m_fDistChng 	= fDistChng;
        m_nAngleChng 	= nAngleChng;
        m_bGotChanges 	= false;
		m_bIsValid 		= false;
    }
//****************************************************************************************************************** gets

	public String getName() 					{ return m_strName; 		}
    public float getDistance() 					{ return m_fDistance; 		}
    public int getAngle() 						{ return m_nAngle; 			}
	public int getTimeStamp()					{ return m_nTimeStamp;		}
	public boolean getIsValid()					{ return m_bIsValid;		}
    public boolean hasChanged() 				{ return m_bGotChanges; 	}
	public float getDistChng() 					{ return m_fDistChng; 		}
    public int getAngleChng() 					{ return m_nAngleChng; 		}

//****************************************************************************************************************** sets

    public void setName(String strName) 		{ m_strName = strName; 		}
    public void setDistance(float fDistance)	{ m_fDistance = fDistance; 	}
    public void setAngle(int nAngle) 			{ m_nAngle = nAngle; 		}
    public void setDistChng(float fDistChng)	{ m_fDistChng = fDistChng; 	}
	public void setAngleChng(int nAngleChng)	{ m_nAngleChng = nAngleChng;}
	public void setGotChanges(boolean bChanged)	{ m_bGotChanges = bChanged; }
	public void setTimeStamp(int nTimeStamp)	{ m_nTimeStamp = nTimeStamp;}
	public void setIsValid(boolean bValid)		{ m_bIsValid = bValid;		}
}
