package betir;

/**
*	This behavior passes the ball to an open teammate that is upfield.  It uses an optimium
*	range to decide which player to pass to.
*/
public class PassBehavior extends RobocupBehavior
{
	public PassBehavior(RobocupEnvironment env, DatagramWrapper dg)
	{
		super(env, dg);
	}

	PlayerInfo m_objFriend;
	public boolean canFire()
	{
		if(m_Env.m_objGoal != null && m_Env.m_objGoal.getDistance() < 20)
			return false;

		if(Math.abs(m_Env.m_vecPosition.getX()) > 45 && (m_Env.m_Player instanceof Goalie))
			return false;

		int nCenter = (m_Env.m_objSelf.getSide() == 'l') ? 0 : 180;
		if(m_Env.m_bHasBall && withinRange(m_Env.m_vecPosition.getAngle(), nCenter, 30))
		{
			if(m_Env.m_aobjFriends.size() > 0)
			{
				m_objFriend = (PlayerInfo)(m_Env.m_aobjFriends.get(0));
				for(int i = 0; i < m_Env.m_aobjFriends.size(); ++i)
				{
					if(withinRange((int)(((PlayerInfo)(m_Env.m_aobjFriends.get(i))).getDistance()), 30, 10) &&
						withinRange(((PlayerInfo)(m_Env.m_aobjFriends.get(i))).getAngle(), 0, 25))
					{
						m_objFriend = (PlayerInfo)(m_Env.m_aobjFriends.get(i));
						break;
					}
				}
				if(m_objFriend != null)
					return true;
			}
		}
		return false;
	}

	public boolean inhibits(RobocupBehavior rb)
	{
		return (rb instanceof KiddySoccerBehavior || rb instanceof CatchTheBall || rb instanceof GoalieReturnToZoneBehavior || rb instanceof ShootGoalBehavior);
	}

	public boolean fire()
	{
		kick((float)(m_Env.m_cfgData.maxpower * m_objFriend.getDistance() / 10),
						(int)(m_objFriend.getAngle() -  3 * m_objFriend.getAngleChng()));
		return false;
	}
}