package betir;

/**
*	Container class that holds all of the player info.
*/
public class PlayerInfo extends ObjectInfo
{
//****************************************************************************************************************** member variables

	/** The name of the team the player is on*/
    private String m_strTeam;
    /** The uniform number of the player*/
    private int m_nUniformNumber = -1;
    /** The body angle*/
	private int m_nBodyAngle;
	/** The head angle*/
	private int m_nHeadAngle;

//****************************************************************************************************************** constructors

	/**
	*	@param strTeam			the name of the team
	*	@param nUniformNumber	the unifor number
	*	@param nTimeStamp		the time stamp
	*/
    public PlayerInfo(String strTeam, int nUniformNumber, int nTimeStamp)
    {
        super(strTeam, nTimeStamp);
        m_strTeam = strTeam;
        m_nUniformNumber = nUniformNumber;
        m_nBodyAngle = 0;
        m_nHeadAngle = 0;
    }

//****************************************************************************************************************** gets

	public String getTeam()								{ return m_strTeam; 				}
    public int getUniformNumber()						{ return m_nUniformNumber; 			}
	public int getBodyAngle()							{ return m_nBodyAngle;				}
	public int getHeadAngle()							{ return m_nHeadAngle;				}

//****************************************************************************************************************** sets

    public void setTeam(String strTeam)					{ m_strTeam = strTeam; 				}
    public void setUniformNumber(int nUniformNumber)	{ m_nUniformNumber = nUniformNumber;}
	public void setBodyAngle(int nBodyAngle)			{ m_nBodyAngle = nBodyAngle;		}
	public void setHeadAngle(int nHeadAngle)			{ m_nHeadAngle = nHeadAngle;		}

//****************************************************************************************************************** equals

    public boolean equals(PlayerInfo p)
    {
        if ((m_nUniformNumber == -1) || (p.getUniformNumber() == -1))
            return false;
        return (m_nUniformNumber == p.getUniformNumber()) && m_strTeam.equals(p.getTeam());
    }
}
