package betir;

/**
*	This is a utility class that has fast integer math functions.
*/
public class QuickIntMath
{
//****************************************************************************************************************** sin/cos/tan

    static public float Sin(int x) { return m_afSin[makeOK(x)]; }
    static public float Cos(int x) { return m_afCos[makeOK(x)]; }
	static public float Tan(int x) { return m_afSin[makeOK(x)] / m_afCos[makeOK(x)];  }
	static private int makeOK(int x)
	{
		while(x < 0)
			x += 360;
		while(x > 360)
			x -= 360;
		return x;
	}


//****************************************************************************************************************** asin/acos/atan

//not done yet
	//static public int ASin(float f) { }
	//static public int ACos(float f) { }
	//static public int ATan(float f) { }


//****************************************************************************************************************** sqrt

    static public int Sqrt(int x)
    {
        if (x >= 0x10000)
            if (x >= 0x1000000)
                if (x >= 0x10000000)
                    if (x >= 0x40000000)
                        return (m_afSqrt[x >> 24] << 8);
                    else
                        return (m_afSqrt[x >> 22] << 7);
                else if (x >= 0x4000000)
                    return (m_afSqrt[x >> 20] << 6);
                else
                    return (m_afSqrt[x >> 18] << 5);
            else if (x >= 0x100000)
                if (x >= 0x400000)
                    return (m_afSqrt[x >> 16] << 4);
                else
                    return (m_afSqrt[x >> 14] << 3);
            else if (x >= 0x40000)
                return (m_afSqrt[x >> 12] << 2);
            else
                return (m_afSqrt[x >> 10] << 1);
        else if (x >= 0x100)
            if (x >= 0x1000)
                if (x >= 0x4000)
                    return (m_afSqrt[x >> 8]);
                else
                    return (m_afSqrt[x >> 6] >> 1);
            else if (x >= 0x400)
                return (m_afSqrt[x >> 4] >> 2);
            else
                return (m_afSqrt[x >> 2] >> 3);
        else
            if (x >=0)
                return m_afSqrt[x] >> 4;
        return -1; // negative argument...
    }



	final static int[] m_afSqrt = {
         0,    16,  22,  27,  32,  35,  39,  42,  45,  48,  50,  53,  55,  57,
         59,   61,  64,  65,  67,  69,  71,  73,  75,  76,  78,  80,  81,  83,
         84,   86,  87,  89,  90,  91,  93,  94,  96,  97,  98,  99, 101, 102,
         103, 104, 106, 107, 108, 109, 110, 112, 113, 114, 115, 116, 117, 118,
         119, 120, 121, 122, 123, 124, 125, 126, 128, 128, 129, 130, 131, 132,
         133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 144, 145,
         146, 147, 148, 149, 150, 150, 151, 152, 153, 154, 155, 155, 156, 157,
         158, 159, 160, 160, 161, 162, 163, 163, 164, 165, 166, 167, 167, 168,
         169, 170, 170, 171, 172, 173, 173, 174, 175, 176, 176, 177, 178, 178,
         179, 180, 181, 181, 182, 183, 183, 184, 185, 185, 186, 187, 187, 188,
         189, 189, 190, 191, 192, 192, 193, 193, 194, 195, 195, 196, 197, 197,
         198, 199, 199, 200, 201, 201, 202, 203, 203, 204, 204, 205, 206, 206,
         207, 208, 208, 209, 209, 210, 211, 211, 212, 212, 213, 214, 214, 215,
         215, 216, 217, 217, 218, 218, 219, 219, 220, 221, 221, 222, 222, 223,
         224, 224, 225, 225, 226, 226, 227, 227, 228, 229, 229, 230, 230, 231,
         231, 232, 232, 233, 234, 234, 235, 235, 236, 236, 237, 237, 238, 238,
         239, 240, 240, 241, 241, 242, 242, 243, 243, 244, 244, 245, 245, 246,
         246, 247, 247, 248, 248, 249, 249, 250, 250, 251, 251, 252, 252, 253,
         253, 254, 254, 255
      };

	final static float m_afSin[] = {
		0.00000f, 0.01745f, 0.03490f, 0.05234f, 0.06976f, 0.08716f, 0.10453f, 0.12187f, 0.13917f, 0.15643f, 0.17365f,
		0.19081f, 0.20791f, 0.22495f, 0.24192f, 0.25882f, 0.27564f, 0.29237f, 0.30902f, 0.32557f, 0.34202f, 0.35837f,
		0.37461f, 0.39073f, 0.40674f, 0.42262f, 0.43837f, 0.45399f, 0.46947f, 0.48481f, 0.50000f, 0.51504f, 0.52992f,
		0.54464f, 0.55919f, 0.57358f, 0.58779f, 0.60182f, 0.61566f, 0.62932f, 0.64279f, 0.65606f, 0.66913f, 0.68200f,
		0.69466f, 0.70711f, 0.71934f, 0.73135f, 0.74314f, 0.75471f, 0.76604f, 0.77715f, 0.78801f, 0.79864f, 0.80902f,
		0.81915f, 0.82904f, 0.83867f, 0.84805f, 0.85717f, 0.86603f, 0.87462f, 0.88295f, 0.89101f, 0.89879f, 0.90631f,
		0.91355f, 0.92050f, 0.92718f, 0.93358f, 0.93969f, 0.94552f, 0.95106f, 0.95630f, 0.96126f, 0.96593f, 0.97030f,
		0.97437f, 0.97815f, 0.98163f, 0.98481f, 0.98769f, 0.99027f, 0.99255f, 0.99452f, 0.99619f, 0.99756f, 0.99863f,
		0.99939f, 0.99985f, 1.00000f, 0.99985f, 0.99939f, 0.99863f, 0.99756f, 0.99619f, 0.99452f, 0.99255f, 0.99027f,
		0.98769f, 0.98481f, 0.98163f, 0.97815f, 0.97437f, 0.97030f, 0.96593f, 0.96126f, 0.95630f, 0.95106f, 0.94552f,
		0.93969f, 0.93358f, 0.92718f, 0.92050f, 0.91355f, 0.90631f, 0.89879f, 0.89101f, 0.88295f, 0.87462f, 0.86603f,
		0.85717f, 0.84805f, 0.83867f, 0.82904f, 0.81915f, 0.80902f, 0.79864f, 0.78801f, 0.77715f, 0.76604f, 0.75471f,
		0.74314f, 0.73135f, 0.71934f, 0.70711f, 0.69466f, 0.68200f, 0.66913f, 0.65606f, 0.64279f, 0.62932f, 0.61566f,
		0.60182f, 0.58779f, 0.57358f, 0.55919f, 0.54464f, 0.52992f, 0.51504f, 0.50000f, 0.48481f, 0.46947f, 0.45399f,
		0.43837f, 0.42262f, 0.40674f, 0.39073f, 0.37461f, 0.35837f, 0.34202f, 0.32557f, 0.30902f, 0.29237f, 0.27564f,
		0.25882f, 0.24192f, 0.22495f, 0.20791f, 0.19081f, 0.17365f, 0.15643f, 0.13917f, 0.12187f, 0.10453f, 0.08716f,
		0.06976f, 0.05234f, 0.03490f, 0.01745f, 0.00000f, -0.01745f, -0.03490f, -0.05234f, -0.06976f, -0.08716f, -0.10453f,
		-0.12187f, -0.13917f, -0.15643f, -0.17365f, -0.19081f, -0.20791f, -0.22495f, -0.24192f, -0.25882f, -0.27564f,
		-0.29237f, -0.30902f, -0.32557f, -0.34202f, -0.35837f, -0.37461f, -0.39073f, -0.40674f, -0.42262f, -0.43837f,
		-0.45399f, -0.46947f, -0.48481f, -0.50000f, -0.51504f, -0.52992f, -0.54464f, -0.55919f, -0.57358f, -0.58779f,
		-0.60182f, -0.61566f, -0.62932f, -0.64279f, -0.65606f, -0.66913f, -0.68200f, -0.69466f, -0.70711f, -0.71934f,
		-0.73135f, -0.74314f, -0.75471f, -0.76604f, -0.77715f, -0.78801f, -0.79864f, -0.80902f, -0.81915f, -0.82904f,
		-0.83867f, -0.84805f, -0.85717f, -0.86603f, -0.87462f, -0.88295f, -0.89101f, -0.89879f, -0.90631f, -0.91355f,
		-0.92050f, -0.92718f, -0.93358f, -0.93969f, -0.94552f, -0.95106f, -0.95630f, -0.96126f, -0.96593f, -0.97030f,
		-0.97437f, -0.97815f, -0.98163f, -0.98481f, -0.98769f, -0.99027f, -0.99255f, -0.99452f, -0.99619f, -0.99756f,
		-0.99863f, -0.99939f, -0.99985f, -1.00000f, -0.99985f, -0.99939f, -0.99863f, -0.99756f, -0.99619f, -0.99452f,
		-0.99255f, -0.99027f, -0.98769f, -0.98481f, -0.98163f, -0.97815f, -0.97437f, -0.97030f, -0.96593f, -0.96126f,
		-0.95630f, -0.95106f, -0.94552f, -0.93969f, -0.93358f, -0.92718f, -0.92050f, -0.91355f, -0.90631f, -0.89879f,
		-0.89101f, -0.88295f, -0.87462f, -0.86603f, -0.85717f, -0.84805f, -0.83867f, -0.82904f, -0.81915f, -0.80902f,
		-0.79864f, -0.78801f, -0.77715f, -0.76604f, -0.75471f, -0.74314f, -0.73135f, -0.71934f, -0.70711f, -0.69466f,
		-0.68200f, -0.66913f, -0.65606f, -0.64279f, -0.62932f, -0.61566f, -0.60182f, -0.58779f, -0.57358f, -0.55919f,
		-0.54464f, -0.52992f, -0.51504f, -0.50000f, -0.48481f, -0.46947f, -0.45399f, -0.43837f, -0.42262f, -0.40674f,
		-0.39073f, -0.37461f, -0.35837f, -0.34202f, -0.32557f, -0.30902f, -0.29237f, -0.27564f, -0.25882f, -0.24192f,
		-0.22495f, -0.20791f, -0.19081f, -0.17365f, -0.15643f, -0.13917f, -0.12187f, -0.10453f, -0.08716f, -0.06976f,
		-0.05234f, -0.03490f, -0.01745f, 0.00000f
	};
	final static float m_afCos[] = {
		1.00000f, 0.99985f, 0.99939f, 0.99863f, 0.99756f, 0.99619f, 0.99452f, 0.99255f, 0.99027f, 0.98769f, 0.98481f,
		0.98163f, 0.97815f, 0.97437f, 0.97030f, 0.96593f, 0.96126f, 0.95630f, 0.95106f, 0.94552f, 0.93969f, 0.93358f,
		0.92718f, 0.92050f, 0.91355f, 0.90631f, 0.89879f, 0.89101f, 0.88295f, 0.87462f, 0.86603f, 0.85717f, 0.84805f,
		0.83867f, 0.82904f, 0.81915f, 0.80902f, 0.79864f, 0.78801f, 0.77715f, 0.76604f, 0.75471f, 0.74314f, 0.73135f,
		0.71934f, 0.70711f, 0.69466f, 0.68200f, 0.66913f, 0.65606f, 0.64279f, 0.62932f, 0.61566f, 0.60182f, 0.58779f,
		0.57358f, 0.55919f, 0.54464f, 0.52992f, 0.51504f, 0.50000f, 0.48481f, 0.46947f, 0.45399f, 0.43837f, 0.42262f,
		0.40674f, 0.39073f, 0.37461f, 0.35837f, 0.34202f, 0.32557f, 0.30902f, 0.29237f, 0.27564f, 0.25882f, 0.24192f,
		0.22495f, 0.20791f, 0.19081f, 0.17365f, 0.15643f, 0.13917f, 0.12187f, 0.10453f, 0.08716f, 0.06976f, 0.05234f,
		0.03490f, 0.01745f, 0.00000f, -0.01745f, -0.03490f, -0.05234f, -0.06976f, -0.08716f, -0.10453f, -0.12187f, -0.13917f,
		-0.15643f, -0.17365f, -0.19081f, -0.20791f, -0.22495f, -0.24192f, -0.25882f, -0.27564f, -0.29237f, -0.30902f,
		-0.32557f, -0.34202f, -0.35837f, -0.37461f, -0.39073f, -0.40674f, -0.42262f, -0.43837f, -0.45399f, -0.46947f,
		-0.48481f, -0.50000f, -0.51504f, -0.52992f, -0.54464f, -0.55919f, -0.57358f, -0.58779f, -0.60182f, -0.61566f,
		-0.62932f, -0.64279f, -0.65606f, -0.66913f, -0.68200f, -0.69466f, -0.70711f, -0.71934f, -0.73135f, -0.74314f,
		-0.75471f, -0.76604f, -0.77715f, -0.78801f, -0.79864f, -0.80902f, -0.81915f, -0.82904f, -0.83867f, -0.84805f,
		-0.85717f, -0.86603f, -0.87462f, -0.88295f, -0.89101f, -0.89879f, -0.90631f, -0.91355f, -0.92050f, -0.92718f,
		-0.93358f, -0.93969f, -0.94552f, -0.95106f, -0.95630f, -0.96126f, -0.96593f, -0.97030f, -0.97437f, -0.97815f,
		-0.98163f, -0.98481f, -0.98769f, -0.99027f, -0.99255f, -0.99452f, -0.99619f, -0.99756f, -0.99863f, -0.99939f,
		-0.99985f, -1.00000f, -0.99985f, -0.99939f, -0.99863f, -0.99756f, -0.99619f, -0.99452f, -0.99255f, -0.99027f,
		-0.98769f, -0.98481f, -0.98163f, -0.97815f, -0.97437f, -0.97030f, -0.96593f, -0.96126f, -0.95630f, -0.95106f,
		-0.94552f, -0.93969f, -0.93358f, -0.92718f, -0.92050f, -0.91355f, -0.90631f, -0.89879f, -0.89101f, -0.88295f,
		-0.87462f, -0.86603f, -0.85717f, -0.84805f, -0.83867f, -0.82904f, -0.81915f, -0.80902f, -0.79864f, -0.78801f,
		-0.77715f, -0.76604f, -0.75471f, -0.74314f, -0.73135f, -0.71934f, -0.70711f, -0.69466f, -0.68200f, -0.66913f,
		-0.65606f, -0.64279f, -0.62932f, -0.61566f, -0.60182f, -0.58779f, -0.57358f, -0.55919f, -0.54464f, -0.52992f,
		-0.51504f, -0.50000f, -0.48481f, -0.46947f, -0.45399f, -0.43837f, -0.42262f, -0.40674f, -0.39073f, -0.37461f,
		-0.35837f, -0.34202f, -0.32557f, -0.30902f, -0.29237f, -0.27564f, -0.25882f, -0.24192f, -0.22495f, -0.20791f,
		-0.19081f, -0.17365f, -0.15643f, -0.13917f, -0.12187f, -0.10453f, -0.08716f, -0.06976f, -0.05234f, -0.03490f,
		-0.01745f, -0.00000f, 0.01745f, 0.03490f, 0.05234f, 0.06976f, 0.08716f, 0.10453f, 0.12187f, 0.13917f, 0.15643f,
		0.17365f, 0.19081f, 0.20791f, 0.22495f, 0.24192f, 0.25882f, 0.27564f, 0.29237f, 0.30902f, 0.32557f, 0.34202f,
		0.35837f, 0.37461f, 0.39073f, 0.40674f, 0.42262f, 0.43837f, 0.45399f, 0.46947f, 0.48481f, 0.50000f, 0.51504f,
		0.52992f, 0.54464f, 0.55919f, 0.57358f, 0.58779f, 0.60182f, 0.61566f, 0.62932f, 0.64279f, 0.65606f, 0.66913f,
		0.68200f, 0.69466f, 0.70711f, 0.71934f, 0.73135f, 0.74314f, 0.75471f, 0.76604f, 0.77715f, 0.78801f, 0.79864f,
		0.80902f, 0.81915f, 0.82904f, 0.83867f, 0.84805f, 0.85717f, 0.86603f, 0.87462f, 0.88295f, 0.89101f, 0.89879f,
		0.90631f, 0.91355f, 0.92050f, 0.92718f, 0.93358f, 0.93969f, 0.94552f, 0.95106f, 0.95630f, 0.96126f, 0.96593f,
		0.97030f, 0.97437f, 0.97815f, 0.98163f, 0.98481f, 0.98769f, 0.99027f, 0.99255f, 0.99452f, 0.99619f, 0.99756f,
		0.99863f, 0.99939f, 0.99985f, 1.00000f
	};
}
