package betir;

import java.util.StringTokenizer;

/**
*	This class keeps all of the information on the player.
*/
public class SelfInfo extends PlayerInfo
{
//****************************************************************************************************************** member variables

    private char m_chSide; 	//'l' for left, 'r' for right

    private String m_strViewQuality;
    private String m_strViewWidth;
    private float m_fStamina;
    private float m_fEffort;
    private float m_fSpeed;
    private int m_nHeadAngle;

    private int m_nKickCount;
    private int m_nDashCount;
    private int m_nTurnCount;
    private int m_nSayCount;
    private int m_nTurnNeckCount;

//****************************************************************************************************************** constructors
    public SelfInfo(String strTeam, int nUniformNumber, char chSide)
    {
        super(strTeam, nUniformNumber, 0);
        m_chSide = chSide;
    }

//****************************************************************************************************************** gets

    public char getSide() 				{ return m_chSide; }
	public String getViewQuality() 		{ return m_strViewQuality; }
    public String getViewWidth() 		{ return m_strViewWidth; }
    public float getStamina() 			{ return m_fStamina; }
    public float getEffort() 			{ return m_fEffort; }
    public float getSpeed() 			{ return m_fSpeed; }
    public int getHeadAngle()	 		{ return m_nHeadAngle; }
    public int getKickCount() 			{ return m_nKickCount; }
    public int getDashCount() 			{ return m_nDashCount; }
    public int getTurnCount() 			{ return m_nTurnCount; }
    public int getSayCount() 			{ return m_nSayCount; }
    public int getTurnNeckCount() 		{ return m_nTurnNeckCount; }

//****************************************************************************************************************** sets

    public void setViewQuality(String strViewQuality) 	{ m_strViewQuality = strViewQuality; }
    public void setViewWidth(String strViewWidth) 		{ m_strViewWidth = strViewWidth; }
    public void setStamina(float fStamina) 				{ m_fStamina = fStamina; }
    public void setEffort(float fEffort) 				{ m_fEffort = fEffort; }
    public void setSpeed(float fSpeed) 					{ m_fSpeed = fSpeed; }
    public void setHeadAngle(int nHeadAngle)	 		{ m_nHeadAngle = nHeadAngle; }
    public void setKickCount(int nKickCount) 			{ m_nKickCount = nKickCount; }
    public void setDashCount(int nDashCount) 			{ m_nDashCount = nDashCount; }
    public void setTurnCount(int nTurnCount) 			{ m_nTurnCount = nTurnCount; }
    public void setSayCount(int nSayCount) 				{ m_nSayCount = nSayCount; }
    public void setTurnNeckCount(int nTurnNeckCount) 	{ m_nTurnNeckCount = nTurnNeckCount; }

//****************************************************************************************************************** parse

	public void parse(String strData)
    {
        StringTokenizer strTok = new StringTokenizer(strData.substring(1)), tokenizer;
        String strTemp;
        //verify that this is indeed a 'sense_body' message
        if(strTok.nextToken().equals("sense_body"))
        {
            setTimeStamp(Integer.parseInt(strTok.nextToken()));

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "view_mode"
            m_strViewQuality = tokenizer.nextToken();
            m_strViewWidth = tokenizer.nextToken();

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "stamina"
            m_fStamina = Float.parseFloat(tokenizer.nextToken());
            m_fEffort = Float.parseFloat(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "speed"
            m_fSpeed = Float.parseFloat(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "head_angle"
            m_nHeadAngle = Integer.parseInt(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "kick"
            m_nKickCount = Integer.parseInt(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "dash"
            m_nDashCount = Integer.parseInt(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "turn"
            m_nTurnCount = Integer.parseInt(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "say"
            m_nSayCount = Integer.parseInt(tokenizer.nextToken());

            strTemp = strTok.nextToken(")");
            tokenizer = new StringTokenizer(strTemp.substring(1));
            tokenizer.nextToken(); //equals "turn_neck"
            m_nTurnNeckCount = Integer.parseInt(tokenizer.nextToken());
        }
    }

//******************************************************************************************************************  tostring

	public String toString()
    {
        StringBuffer rtnval = new StringBuffer();
        rtnval.append(super.toString());
        rtnval.append("view_quality: " + m_strViewQuality);
        rtnval.append("view_width: " + m_strViewWidth);
        rtnval.append("stamina: " + m_fStamina);
        rtnval.append("effort: " + m_fEffort);
        rtnval.append("speed: " + m_fSpeed);
        rtnval.append("head_angle: " + m_nHeadAngle);
        rtnval.append("kick: " + m_nKickCount);
        rtnval.append("dash: " + m_nDashCount);
        rtnval.append("turn: " + m_nTurnCount);
        rtnval.append("say: " + m_nSayCount);
        rtnval.append("turn_neck: " + m_nTurnNeckCount);
        return rtnval.toString();
    }
}
