package betir;

/**
*	This class creates the zone player.  It adds seven behaviors: StartBehavior,
*	KiddySoccerBehavior, ReturnToZoneBehavior, StayPutBehavior, PassBehavior
*	CornerKickBehavior, ShootGoalBehavior.
*/
public class ZonePlayer extends Player
{
	ZonePlayer(RobocupEnvironment theEnv, DatagramWrapper dg, int nPlayerNum, int nZone)
	{
		super(theEnv, dg, nPlayerNum, nZone);

		//System.out.println("ZonePlayer");

		StartBehavior start = new StartBehavior(theEnv, dg);
		addBehavior(start);

		KiddySoccerBehavior dtb = new KiddySoccerBehavior(theEnv, dg);
		addBehavior(dtb);

		ReturnToZoneBehavior rtzb = new ReturnToZoneBehavior(theEnv, dg);
		addBehavior(rtzb);

		StayPutBehavior spb = new StayPutBehavior(theEnv, dg);
		addBehavior(spb);

		PassBehavior pb = new PassBehavior(theEnv, dg);
		addBehavior(pb);

		CornerKickBehavior ckb = new CornerKickBehavior(theEnv, dg);
		addBehavior(ckb);

		ShootGoalBehavior sgb = new ShootGoalBehavior(theEnv, dg);
		addBehavior(sgb);
	}
}
