package betir;

import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

/**
*   This is the main class that starts the client which creates the soccer players.
*/
public class boot
{
    public static void main(String args[]) throws SocketException, IOException
    {
		// variables for holding data from the init message
        int numberOfAgents;
        String  strPlayMode;
        PrintWriter debug;

		System.out.print("betir agents firing up....");

		int playertype			= Integer.parseInt(CommandLineUtil.LocateParameter(args, "-playertype=", "0"));
        String debugFileName 	= CommandLineUtil.LocateParameter(args, "-debug=", "");
        boolean display 		= Boolean.valueOf(CommandLineUtil.LocateParameter(args, "-display=", "false")).booleanValue();
        String configFilename 	= CommandLineUtil.LocateParameter(args, "-config=", "server.conf");
        int port 				= Integer.parseInt(CommandLineUtil.LocateParameter(args, "-port=", "6000"));
        String team 			= CommandLineUtil.LocateParameter(args, "-team=", "BETIR");
        numberOfAgents 			= Integer.parseInt(CommandLineUtil.LocateParameter(args, "-num=", "1"));
        numberOfAgents 			= (numberOfAgents > 0) ? numberOfAgents : 1;
        String hostName 		= CommandLineUtil.LocateParameter(args, "-host=", "");
        String version			= CommandLineUtil.LocateParameter(args, "-version=", "7.00");
        boolean useGoalie 		= Boolean.valueOf(CommandLineUtil.LocateParameter(args, "-use_goalie=", "false")).booleanValue();
        StringTokenizer sPositions = new StringTokenizer(CommandLineUtil.LocateParameter(args, "-positions=", ""), ";");
		boolean bOffsides		= Boolean.valueOf(CommandLineUtil.LocateParameter(args, "-offsides=", "false")).booleanValue();
        // variable to hold the configuration data, typically loaded from a
        // the file named server.conf
        ConfigurationData cfgData 	= new ConfigurationData(configFilename);

		int nNumZonePlayers = bOffsides ? 6 : 8;

        //create the agents
        for(int counter = 1; counter <= numberOfAgents; counter++)
        {
			String sPosition = new String();
			if(sPositions.hasMoreTokens())
				sPosition = sPositions.nextToken();

            System.out.print(counter + " ");
			if (debugFileName.length() != 0)
                debug = new PrintWriter(new FileWriter(debugFileName + counter));
            else
                debug = null;
            DatagramWrapper dgWrapper = new DatagramWrapper(hostName, port, 1024, debug);

            // initialize communciations with the server by sending an init command
            if (useGoalie && counter == numberOfAgents)
                dgWrapper.send("(init " + team + "(version " + version + ") (goalie))");
            else
                dgWrapper.send("(init " + team + "(version " + version + "))");

            // read the server's reply... format of the response message is found in
            // the soccer server manual
            String initReply = dgWrapper.receive();

            // strip the leading '(' and tokenize on ' ' and ')'
            StringTokenizer strtok = new StringTokenizer(initReply.substring(1), " )");

            // verify the message read is indeed the initReply
            if(strtok.nextToken().equals( "init" ))
            {
                char side 					= strtok.nextToken().charAt(0);
                int uniformNumber			= Integer.parseInt( strtok.nextToken() );
                String Mode 				= strtok.nextToken();
                // communication with server is up... initialize the GlobalMemory and Player objects
				Player thePlayer;
				RobocupEnvironment environment 	= new RobocupEnvironment(cfgData, display, new SelfInfo(team, uniformNumber, side));
                if(useGoalie && counter == numberOfAgents)
                    thePlayer = new Goalie(environment, dgWrapper, uniformNumber, 10);
                else if(counter > nNumZonePlayers)
                	thePlayer = new Attacker(environment, dgWrapper, uniformNumber, counter - 1);
                else
                	thePlayer = new ZonePlayer(environment, dgWrapper, uniformNumber, counter - 1);
			}
            else
            {
                System.err.println( "Failure during server initialization process!" );
                System.exit(0);
            }
        }
		System.out.println("...kick some ass!");
    }
}
